package myPlugins;

import com.mathworks.toolbox.javabuilder.MWArray;
import com.mathworks.toolbox.javabuilder.MWException;

import matlabadd.Adder;
import tersus.model.BuiltinModels;
import tersus.model.Model;
import tersus.model.Role;
import tersus.runtime.EngineException;
import tersus.runtime.FlowInstance;
import tersus.runtime.Plugin;
import tersus.runtime.RuntimeContext;
import tersus.runtime.SlotHandler;

public class Test extends Plugin{
	private static final Role N1 = Role.get("<N1>");
	private static final Role N2 = Role.get("<N2>");
	private static final Role TEST = Role.get("<Test>");
	private SlotHandler n1Trigger,n2Trigger, testExit;
	public void initializeFromModel(Model model) {
		super.initializeFromModel(model);
		n1Trigger = getRequiredMandatoryTrigger(N1, Boolean.FALSE, BuiltinModels.NUMBER_ID);
		n2Trigger = getRequiredMandatoryTrigger(N2, Boolean.FALSE, BuiltinModels.NUMBER_ID);
		testExit = getRequiredExit(TEST, Boolean.FALSE, BuiltinModels.NUMBER_ID);
	}

	public void start(RuntimeContext context, FlowInstance flow) {
		int n1 = getTriggerValue(n1Trigger, context, flow, 0);
		int n2 = getTriggerValue(n2Trigger, context, flow, 0);
		if (n1 < 0 || n2 <0)
			fireError(context, flow, new EngineException("Cannot compute factorial of a negative number",null,null));
		long f=0;
		try {
			f = test(n1,n2);
		} catch (MWException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		setExitValue(testExit, context, flow, f);
	}
	
	private long test(int a,int b) throws MWException{
		Object result[]=null;
		Adder myAdd=new Adder();
		result=myAdd.add(1,a,b);
		double[] res= (double [])((MWArray)result[0]).getData();
		return (long) res[0];
		//return 40*n;
	}	
}
